// My Modeler.C creates OpenGL interface, Maya Style //

/*
Mesh_Generator uses well known height map techniques and algorythms, these are widely used in the games industry to produce terrains for levels in games, the innovative twist is to consider the features of a face as topology, therefore , meshes of faces can be produced using these procedures.

this procedure has some limitations as the produced mesh is semi-open , that is, is not a closed geometry
solid ( as a head would be) so in order to reproduce a head using this method, 4 photographs had to be used, orthogonaly taked from front,side_1,side_2,back, the 4 produced meshes will then be joined.

The procedure presented here will produce the mesh for a face only.

Credit is given to http://nehe.gamedev.net, http://www.gametutorials.com/, from where inspiration was drawn, and a couple of code snippets too. The whole rest and the  OpenGL rendering context was written by me with a little help of Rob (the bloke).

*/



// gcc -o prog test.c -lGL -lGLU -lglut

#include<GL/gl.h>
#include<GL/glu.h>
#include <GL/glut.h>
#include"MyModeler.h"
#include"ImageLoader.c"

/*--------initialise variables--------------------------------------------*
 *
 *
 *------------------------------------------------------------------------*/

int width,height,depth;
int oldx, oldy;

bool bAlt,bCtrl;
bool mybutton[3] ;

/*------initialise arrays (for rotation and translation)to values---------*
 *
 *
 *------------------------------------------------------------------------*/


float OrthoView[3] = {25,0,50} ; /*--array for orthogonal view values--*/

float Rotation[3] = {45,45,0};  /*--array for rotation angles for x , y --*/

float myView[3] = {0,0,50};     /*--array for myCustomCamera--*/

/*------function definitions----------------------------------------------*
 *
 *
 *------------------------------------------------------------------------*/

 void Load_Image(void)
 {
	glShadeModel(GL_SMOOTH);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

 	LoadRawFile("data/face_pos.raw", MAP_SIZE * MAP_SIZE, g_HeightMap);

 	printf(" initialise OK! \n");

}
/*----------------------------drawGrid------------------------------------*
 *																		  *
 *	 draws the reference "floor" grid" and the 3 axis																	  *
 *------------------------------------------------------------------------*/

void drawGrid(void)

{
	int i;
	
	for(i=0;i != 11;i++)
	{
		glColor3f(1,1,1);
		glLineWidth(1.0f);
		
		glBegin(GL_LINES);
		
				
			glVertex3f((i*4)-20, 0,  -20);
			glVertex3f((i*4)-20, 0,  20);
			glVertex3f(-20, 0, (i*4)-20);
			glVertex3f(20, 0, (i*4)-20);
			
		glEnd();
		
	}
	
	glLineWidth(2.0f);
	glBegin(GL_LINES);
	
		glColor3f(1,0,0);
		glVertex3f(0,0,0);
		glVertex3f(-3,0,0);
		
		glColor3f(0,1,0);
		glVertex3f(0,0,0);
		glVertex3f(0,3,0);
		
		glColor3f(0,0,1);
		glVertex3f(0,0,0);
		glVertex3f(0,0,3);
		
	glEnd();	
}

/*--drawGrid--*/

/*------------------------------drawGeom----------------------------------*
 *																		  *
 *------------------------------------------------------------------------*/



void drawGeom()
{
	

	
	glTranslatef(0,0,0);
	glColor3f(1,0.5,1);
	glutWireCube(20);
	
	
		
}

/*--drawGeom--*/


/*------------------------------draw--------------------------------------*
 *	AKA as display														  *			  
 *------------------------------------------------------------------------*/

/*------------------------------------------------------------------------*
 *  first in 2d draws a background panel divided in 4 sections            *
 *  (with diferent colors),divided by lines.                              *
 *------------------------------------------------------------------------*/

void draw()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glDisable(GL_DEPTH_TEST);
	glViewport(0,0,width,height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();	
	glOrtho(0,width,0,height,-200,200);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity(); 
	
	
	/*-------------- background red viewport  ----------------*/

	glBegin(GL_QUADS);
		glColor3f(0.3,0.1,0.1);
		glVertex2i(0,0);
		glVertex2i(width/2,0);
		glVertex2i(width/2,height/2);
		glVertex2i(0,height/2);
	glEnd();
	
	
	/*-------------- background green viewport  ----------------*/

	glBegin(GL_QUADS);
		glColor3f(0.1,0.3,0.1);
		glVertex2i(width/2,0);
		glVertex2i(width,0);
		glVertex2i(width,height/2);
		glVertex2i(width/2,height/2);
	glEnd();
	
	
	/*-------------- background blue viewport  ----------------*/
	
	glBegin(GL_QUADS);
		glColor3f(0.1,0.1,0.3);
		glVertex2i(width/2,height/2);
		glVertex2i(width,height/2);
		glVertex2i(width,height);
		glVertex2i(width/2,height);
	glEnd();
	
	
	
	/*-------------- viewport division lines  ----------------*/

	glColor3f(0.5,0.5,0.5);
	glLineWidth(3);
	glBegin(GL_LINES);
		glVertex2i(width/2,0);
		glVertex2i(width/2,height);
		
		glVertex2i(0,height/2);
		glVertex2i(width,height/2);
	glEnd();
	glEnable(GL_DEPTH_TEST);

/*------------------------------------------------------------------------*
 *  then in 3d creates the viewports in the 4 sections specified          *
 *   by background colors (and lines)                                     *
 *------------------------------------------------------------------------*/


	/*----------------------------  creating other perspective   viewport ---------------*/
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();	
	glViewport(0,height/2,width/2,height/2);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	gluPerspective(45,(float)width/height,1,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	/*first 3 param are position of cam*/
	/*second 3 param are where you look at*/
	/*last 3 param are rotation of cam*/
	glTranslatef(-myView[0],-myView[1],-myView[2]);
	glRotatef(Rotation[0],1,0,0);
	glRotatef(Rotation[1],0,1,0);


	glPushMatrix();
	//drawGeom();
	glTranslatef(0,0,0);
	drawGLScene();
	glPopMatrix();

	glPushMatrix();
	drawGrid();
	glPopMatrix();
	
	/*----------------------------  creating other orto.front -BLUE_ viewport ---------------*/

	glViewport(width/2,height/2,width,height/2);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glOrtho(OrthoView[0] - OrthoView[2],OrthoView[0]+OrthoView[2],OrthoView[1]-OrthoView[2]/2.5,OrthoView[1]+OrthoView[2]/2.5,-100,100 );
	
	glRotatef(90, 1,0,0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0,0,0);
	
	glPushMatrix();
	//drawGeom();
	drawGLScene();
	glPopMatrix();
	
	glPushMatrix();
	drawGrid();
	glPopMatrix();
	
	/*-----------------------  creating side. -RED- viewport  --------------------------------*/
	
	glViewport(0,0,width/2,height/2 );
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	glOrtho(-20,20,-15,15,-100,100);

	glRotatef(90, 0,1,0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0,0,0);
	
	
	glPushMatrix();
	//drawGeom();
	drawGLScene();
	glPopMatrix();
	
	glPushMatrix();
	drawGrid();
	glPopMatrix();
	
	
	
	/*-----------------------  creating other orto.top?  -GREEN_ viewport  --------------------------------*/

	glViewport(width/2,0,width/2,height/2);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	/*glOrtho(-40,40,-30,30,-100,100 );*/
	glOrtho(-20,20,-15,15,-100,100);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0,0,0);
	
	glPushMatrix();
	//drawGeom();
	drawGLScene();
	glPopMatrix();

	glPushMatrix();
	drawGrid();
	glPopMatrix();
	
	

	glutSwapBuffers();
	glutPostRedisplay();
	
	
}

/*--draw AKA as display--*/


/*-----------------------------------resize-------------------------------*
 *																		  *
 *	keeps aspect ratio of objects when window is resized				  *													  *
 *------------------------------------------------------------------------*/



void resize(int w,int h)
{
	if(h==0)  h =1;
	
	width = w;
	height = h;
	
	glViewport(0,0,w,h);
}

/*--resize--*/



/*-------------------------------clamp------------------------------------*
 *																		  *
 *   Ensures rotation is executed between 0 - 360 degrees				  *												      *
 *------------------------------------------------------------------------*/

void clamp(float *c)
{
	int i;
	
	for(i=0; i<3 ;i++)
		
		if(c[i] > 360 || c[i] < -360)
			
			c[i] = 0;
	
}

/*--clamp--*/


/*-------------------------------MouseButton------------------------------*
 *																		  *
 *	defines -clicked/released- stated of button & associates each button  *
 *  whith a keyboard key				                                  *
 *------------------------------------------------------------------------*/


void MouseButton(int button,int state,int x, int y)
{

	oldx = x;
	oldy = y;



		if ( 0 != (glutGetModifiers() & GLUT_ACTIVE_ALT))

			bAlt = true;


		else

			bAlt = false;

		if ( 0 != (glutGetModifiers() & GLUT_ACTIVE_CTRL) )

			bCtrl = true;

		else

			bCtrl = false;
		

	switch(button)

			{

				case GLUT_LEFT_BUTTON:



				if(state == GLUT_DOWN)
					mybutton[0] = true;



				else
					mybutton[0] = false;

						

				
				break;
				
				case GLUT_MIDDLE_BUTTON:
				if(state == GLUT_DOWN)
					mybutton[1] = true;
				
				else
					mybutton[1] = false;
				
				break;
				
				case GLUT_RIGHT_BUTTON:
				if(state == GLUT_DOWN)
					mybutton[2] = true;
				
				else
					mybutton[2] = false;
				
				break;
				
				default:
				
				break;
				
			}

	glutPostRedisplay();
		
}

/*--MouseButton--*/


/*-----------------------------MouseMotion--------------------------------*
 *																		  *
 *	keeps records of mouse movement (coordinates of when a button is      *
 *  first clicked and coordinates of where it is released)				  *												   	
 * 	can calculate distance travelled !!									  *								 
 *------------------------------------------------------------------------*/


void MouseMotion(int x, int y)
{

if(x >= (width/2) && x <=(width) && y >= (0) && y < (height/2))/*--added to limit influence 
																to perspective viewp*/

	{
		if(bCtrl)
		{
			if(mybutton[0] && mybutton[1])
			{
			OrthoView[2] += (oldx - x) * 0.05f;
			OrthoView[2] -= (oldy - y) * 0.05f;
			}

	
		else
		if(mybutton[1]) {
			OrthoView[0] += (oldx -x) * 0.1f;
			OrthoView[1] -= (oldy -y) * 0.1f;
			}
			oldx = x;
			oldy = y;
		}
glutPostRedisplay();
	}

	

if(x >= (0) && x <=(width/2) && y >= (0) && y < (height/2))/*--added to limit influence 
																to perspective viewp*/
	{
		if(bAlt)
		{
			if(mybutton[0] && mybutton[1])
				{
				myView[2] += (oldx - x) * 0.05f;
				myView[2] -= (oldy - y) * 0.05f;
			
				}
	
		
			
		else if (mybutton[0])
			{
			Rotation[1] -= (oldx -x);
			Rotation[0] -= (oldy -y);
			
			}
			
			else
			{
			myView[0] += (oldx -x) * 0.1f;
			myView[1] -= (oldy -y) * 0.1f;

			}
			
			clamp (Rotation);

			oldx = x;
			oldy = y;

		}

	glutPostRedisplay();

	}
			
}

/*--MouseMotion--*/

/*------------------------------- KEYBOARD -----------------------------------------------------
*
*
-----------------------------------------------------------------------------------------------*/

void keyboard(unsigned char key,int x, int y)

{
switch(key){

			case 'w':
		if (filling==0)
		{
			glPolygonMode (GL_FRONT_AND_BACK, GL_FILL); // Polygon rasterization mode (polygon filled)
			filling=1;
		}
		else
		{
			glPolygonMode (GL_FRONT_AND_BACK, GL_LINE); // Polygon rasterization mode (polygon outlined)
			filling=0;
		}

		break;

		case 'l':

		  Load_Image();

		break;

		default:
		break;
	}


}


/*---------------------------main prog -----------------------------------*
 *																		  *
 *------------------------------------------------------------------------*/

int main(int argc,char** argv)
{

	
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(50,50);

	glutCreateWindow("Mesher");
	glutDisplayFunc(draw);
	
	glutReshapeFunc(resize);
	
	glutMouseFunc(MouseButton);
	glutMotionFunc(MouseMotion);
	glutKeyboardFunc(keyboard);
	
	
	glEnable(GL_DEPTH_TEST);

	glutMainLoop();

	
	
	return 0;
}

/*--main--*/